﻿Type=Service
Version=2.7
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: false
#End Region

'Service module
Sub Process_Globals
	Dim Notification As Notification
	Dim Timer1 As Timer
	
	Dim ph As Phone
    Dim closeDialog As Intent
	Type KioskMainSettingsTyp(KioskTimerAction,MainApp,AllowedAppsIni As String)
	Type AktStatusTyp (BatLevel As Int,BatPlugged As Boolean,ScreenOn As Boolean)
	Type ForcedSettingsTyp (Brightness,AirPlaneModeOn,BluetoothOn,AutoTime,InstallNonMarketApps,AdbEnabled,WifiOn As Int)
	Type TmpSettingsTyp (Volume As Int)
	
	Dim KiokMainSetting As KioskMainSettingsTyp
	Dim AktStatus As AktStatusTyp
	Dim ForcedSettings As ForcedSettingsTyp
    Dim AllowedApps As List
	Dim PE As PhoneEvents
	Dim TimerHighSpeed As Int = 200
	Dim TimerLowSpeed As Int  = 10000
	Dim Wiedererwecken As Boolean =False
	Dim awake As PhoneWakeState
	Dim LastSekTimerCall As Long
	Dim Last5MinTimerCall As Long
	Dim jhw As JhWifi
	Dim myWIFI_Test As ToggleWifiData
	
  	Dim PfadEinstellungen As String
	Dim PfadPrgData,Section As String  

	Dim ScreenShotsBeiStart As List
	
End Sub




Sub Service_Create
    Dim Ini As CIniFile 
	Dim IniAllowedApps As CIniFile 
	Dim i As Int
	Dim IniName As String  
	
	


	' Initialize wifi
	jhw.Initialize
	myWIFI_Test.Initialize

	
	AllowedApps.Initialize
	KiokMainSetting.Initialize
	ForcedSettings.Initialize
	
	' erlaubte Apps einlesen
	
	PE.Initialize("PE")
	AktStatus.ScreenOn= IsScreenOn
	
	
	PfadPrgData = File.DirAssets

	PfadEinstellungen = PfadPrgData 
	IniName = "kiosk.ini"
	Try 
		Ini.Initialize(PfadEinstellungen,IniName)
		Section = "Kiosk" 
		KiokMainSetting.KioskTimerAction = Ini.Get(Section, "KioskTimerAction", "On") 
		KiokMainSetting.MainApp = Main.PackageName 
		KiokMainSetting.AllowedAppsIni =Ini.Get(Section, "AllowedAppsIni", "appstart.ini")

		Section = "ForcedStettings" 
		ForcedSettings.Brightness=			Ini.Get(Section, "Brightness", "255") 
		ForcedSettings.AirPlaneModeOn=		Ini.Get(Section, "AirPlaneModeOn", "0")
		ForcedSettings.BluetoothOn=			Ini.Get(Section, "BluetoothOn", "0")
		ForcedSettings.AutoTime=			Ini.Get(Section, "AutoTime", "1")
		ForcedSettings.InstallNonMarketApps=Ini.Get(Section, "InstallNonMarketApps", "1")
		ForcedSettings.AdbEnabled=			Ini.Get(Section, "AdbEnabled", "1")
		ForcedSettings.WifiOn=				Ini.Get(Section, "WifiOn", "1")
		

	  
	  AllowedApps.add(KiokMainSetting.MainApp)
	  Log(KiokMainSetting)
	  
    Catch
	  Log("Ini File " & PfadEinstellungen &"/"& IniName & "nicht in Ordnung")
	End Try
	
	
	Try 
	  IniAllowedApps.Initialize(PfadEinstellungen,KiokMainSetting.AllowedAppsIni)
	  For i = 0 To 99	 
	    Dim AppSystemName As String
		Section="Menue"&(i+1)
		AppSystemName =  IniAllowedApps.Get(Section, "AppSystemName", "")
		If AppSystemName <> "" Then
          AllowedApps.add(AppSystemName)
		  Log(AppSystemName)
		Else 
	    	Exit
	   	End If	   
	Next
    Catch
	  Log("Ini File " & PfadEinstellungen &"/"& KiokMainSetting.AllowedAppsIni & "nicht in Ordnung")
	End Try
	
	AllowedApps.add("android")     ' allow home application default chooser to be in foreground

	
	If Notification.IsInitialized = False Then
		Notification.Initialize
		Notification.Icon = "icon"
		Notification.SetInfo("Kiosk app", "Kiosk app", Main)
		Notification.Sound = False
		Notification.Vibrate = False
	End If
	
	
	closeDialog.Initialize( "android.intent.action.CLOSE_SYSTEM_DIALOGS","")

	Timer1.Initialize("Timer1", TimerHighSpeed)
    Timer1.Enabled = True  
	
	
	Service.StartForeground(1, Notification)
	Log("Service is create ")
		
		
	ScreenShotsBeiStart = File.ListFiles(File.DirRootExternal&"/Pictures/Screenshots")
	If ScreenShotsBeiStart.IsInitialized Then 
		ScreenShotsBeiStart.sort(True)
	End If
	
	
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	
	Log("Service is start ")	
    
	'If IsPaused(Main) Then Timer1.Enabled = True
End Sub

Sub Service_Destroy
	Log("Service is stoppped ")	

	Service.StopForeground(1)
	Timer1.Enabled = False
End Sub

Sub Timer1_Tick

    Dim CallSekTimer As Boolean
	Dim Call5MinTimer As Boolean
	Dim now As Long =  DateTime.now

	CallSekTimer = (now-LastSekTimerCall) > 1000
	Call5MinTimer = (now-Last5MinTimerCall) > 1000*60*5
	
	ph.SendBroadcastIntent(closeDialog)

	Dim Top As String
	Dim AllowedIsTop As Boolean
	Top =  GetTopActivity

	AllowedIsTop=False
	For i = 0 To AllowedApps.Size-1
		If Top= AllowedApps.Get(i) Then
			AllowedIsTop=True
			Exit	
		End If
	Next

	If Not (AllowedIsTop) Then
	    Log(" Kein erlaubte App top " & Top )
'		If Main.KioskMode Then 
			StartActivity(Main)
			Log(" Start Main" )
'		End If
	End If
	
	If IsScreenOn Then
	  Timer1.Interval = TimerHighSpeed
	Else
	  Timer1.Interval = TimerLowSpeed  
	  Log ("TimerLangsam")
	  Log( "Battery: " & AktStatus.BatLevel & "%" & " Plugged " &  AktStatus.BatPlugged)
	End If
  
  
    If CallSekTimer Then
	    LastSekTimerCall=DateTime.now

		If AktStatus.ScreenOn Then
			BearbeiteForcedSettings
		End If
		
	End If
  
	If Call5MinTimer Then
	    Last5MinTimerCall=DateTime.now

		Timer5min
		
	End If
 
End Sub



' gives a string of the activity on top of the stack
Sub GetTopActivity As String 
   
    Dim o As OperatingSystem
	
	o.Initialize("OS")
	
    Dim tasks As List = o.getRecentTasks(1, 0)
    For Each task As Object In tasks
        Dim r As Reflector
        r.Target = task
        Dim bi As Object = r.GetField("baseIntent")
		
        If bi <> Null Then
		    
            r.Target = bi
            r.Target = r.RunMethod("getComponent")
            Return r.RunMethod("getPackageName")
		Else 
		    Return ""
        End If
		
    Next
    
End Sub 


Sub IsScreenOn As Boolean
    Dim r As Reflector
    r.Target = r.GetContext
    r.Target = r.RunMethod2("getSystemService", "power", "java.lang.String")
    Return r.RunMethod("isScreenOn")
End Sub

Sub PE_BatteryChanged(Level As Int, Scale As Int, Plugged As Boolean, Intent As Intent)
 
	Log( "Battery: " & Level & "%" & " Plugged " & Plugged)

	If  AktStatus.BatPlugged <> Plugged Then 
		'Stecker gesteckt/ausgestecked 
		If Not(Plugged) AND Not (AktStatus.ScreenOn) Then
		 	Aufwecken
			Log("aufwecken battery changed")
		End If
	End If
	
	AktStatus.BatLevel=Level 
	AktStatus.BatPlugged=Plugged   
End Sub

Sub PE_ScreenOn (Intent As Intent)
	Log("Screen On")
	AktStatus.ScreenOn=True
	Timer1.Interval = TimerHighSpeed

    If Wiedererwecken Then
'	    Log("call transparent zum aufwecken")
'		CallSubDelayed("Transparent","Aufwecken")
	    Log("call Main zum aufwecken")
		CallSubDelayed("Main","ReturnFromSleep")
	    Wiedererwecken=False
	End If	
End Sub

Sub PE_ScreenOff(Intent As Intent)
	Log("Screen off")
	AktStatus.ScreenOn=False
	'StartActivity(AppLauncher)
	
	'StartActivity(Main)

	If AktStatus.BatPlugged Then
	    ' Tablet in Docking Station daher kein automisches erwecken  
	    Wiedererwecken=False
	Else
        ' Wenn Bildschirmn ausgeschaltet wird nur neustarten wenn nicht in docking station	
		Aufwecken
		Log("aufwecken screen off")
	End If
	
End Sub

Sub Aufwecken
	awake.ReleaseKeepAlive
	awake.KeepAlive(True)
 	Wiedererwecken=True
	DoEvents

End Sub

Sub BearbeiteForcedSettings
	
	
	
	Dim ForcedSettingsAkt As ForcedSettingsTyp
	Dim AutoBrightness As Int
	
	
	
	ForcedSettingsAkt.Initialize
	
	ForcedSettingsAkt.Brightness=ph.GetSettings("screen_brightness")
	ForcedSettingsAkt.AirPlaneModeOn=ph.GetSettings("airplane_mode_on")
	ForcedSettingsAkt.BluetoothOn=ph.GetSettings("bluetooth_on")
	ForcedSettingsAkt.AutoTime=ph.GetSettings("auto_time")
	ForcedSettingsAkt.InstallNonMarketApps=ph.GetSettings("install_non_market_apps")
	ForcedSettingsAkt.AdbEnabled=ph.GetSettings("adb_enabled")
	If myWIFI_Test.isWIFI_enabled Then 
		ForcedSettingsAkt.WifiOn=1
	Else
		ForcedSettingsAkt.WifiOn=0 
	End If
	
	AutoBrightness = ph.GetSettings("screen_brightness_mode")
	If AutoBrightness = 1 Then
		ForcedSettingsAkt.Brightness = -1
	End If 
	
	 
	' Force wifi 
	
	If ForcedSettingsAkt.WifiOn <>  ForcedSettings.WifiOn Then
		Log("wifi toggeln da anders als ini filevorgabe")
		myWIFI_Test.toggleWIFI
	End If
	


	If	(ForcedSettingsAkt.Brightness <>  ForcedSettings.Brightness) OR  _
		(ForcedSettingsAkt.BluetoothOn <>  ForcedSettings.BluetoothOn) OR  _
		(ForcedSettingsAkt.AutoTime <>  ForcedSettings.AutoTime)   _
	Then
	
		CallSubDelayed("Transparent","ForceSettings")
	End If
	

	
	Dim IniName As String

	IniName = "tmpSettings.ini"
	If Not(File.Exists(File.DirInternal,IniName)) Then
  		' falls die laustärke nicht vom menuepunt überschriebn ist dann aus
		SetForcedVolume
	Else
		SetTmpVolume
	End If
	

End Sub

Sub SetForcedVolume
	If ph.GetVolume(ph.VOLUME_MUSIC) <> 0 Then
		Log("Lautstärke wieder auf 0 ")
		ph.SetVolume(ph.VOLUME_MUSIC,0,False)
	End If	
End Sub

Sub SetTmpVolume
	Dim Ini As CIniFile
	Dim MaxVol As Int
	Dim IniName As String
	Dim AktLautstaerkeSollProz As Int
	Dim AktLautstaerkeSoll As Int
	

	IniName = "tmpSettings.ini"
	If File.Exists(File.DirInternal,IniName) Then
		MaxVol=ph.GetMaxVolume(ph.VOLUME_MUSIC)
	    Ini.Initialize(File.DirInternal,IniName)
		AktLautstaerkeSollProz= Ini.Get("TmpSettings", "Lautstaerke", "0")
		AktLautstaerkeSoll= (AktLautstaerkeSollProz*MaxVol)/100 
	End If

	If ph.GetVolume(ph.VOLUME_MUSIC) <> AktLautstaerkeSoll Then
		Log("Lautstärke auf  " & AktLautstaerkeSoll & " " &MaxVol& " " &AktLautstaerkeSollProz)
		ph.SetRingerMode(ph.RINGER_NORMAL)
		ph.SetMute(ph.VOLUME_MUSIC,False)
		ph.SetVolume(ph.VOLUME_MUSIC,AktLautstaerkeSoll,False)
		
	End If	
End Sub

Sub Timer5min
	Log("5min timer")
	Dim liste As List
	Dim NewScreenShot As String
	
	'lösche alle screenshots die während kiosk mode gemacht wurden
	If ScreenShotsBeiStart.IsInitialized Then
		liste = File.ListFiles(File.DirRootExternal&"/Pictures/Screenshots")
		liste.Sort(True)
		If liste.IsInitialized Then
			For i = ScreenShotsBeiStart.Size To liste.Size-1
				NewScreenShot=liste.Get(i)
				Log(NewScreenShot)
				Try
					File.Delete(File.DirRootExternal&"/Pictures/Screenshots",NewScreenShot)
					Log(NewScreenShot & " erfolgreich geloescht")
				Catch
					Log(NewScreenShot & " konnte nicht geloescht werden")
				End Try
			Next		  
		End If
	End If	
	
End Sub
